<template>
    <q-page class="bg-base">
        <Container :max-height="1" class="full-width column ">

            <FloorChart ref='Chart' v-if="options != null" class="col q-pa-sm" style="box-sizing: border-box" :settings="GraphSettings.StoreValue" :options="options" :days="days"/>
            <q-skeleton v-else type="rect" class="full-width col"/>
            <q-btn color="primary" @click="dialog = true">Change Graph</q-btn>

        </Container>
        <q-dialog persistent v-model="dialog" position="bottom" style="max-width: 800px; width: 100%">
            <div class="bg-base q-pa-lg full-width q-gutter-y-lg">
                <div class="row justify-between">
                    <q-btn icon="get_app" label="download" color="primary" :loading="loading">
                        <q-menu>
                            <q-list>
                                <q-item clickable v-close-popup @click="Download('jpeg')">
                                    <q-item-section>JPEG</q-item-section>
                                </q-item>
                                <q-item clickable v-close-popup @click="Download('png')">
                                    <q-item-section>PNG</q-item-section>
                                </q-item>
                                <q-item clickable v-close-popup @click="Download('pdf')">
                                    <q-item-section>PDF</q-item-section>
                                </q-item>
                            </q-list>
                        </q-menu>
                    </q-btn>
                    <q-btn primary icon="clear" color="primary" @click="dialog = false" label="close"/>

                </div>
                <FloorChartOptions :days="days"/>
            </div>
        </q-dialog>
    </q-page>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
import {Component, Vue, Watch} from 'vue-property-decorator';
import Container from "components/Core/Container.vue";
import FloorChartOptions from "components/Charts/FloorChartOptions.vue";
import {format} from "date-fns";
import FloorChart from "components/Charts/FloorChart.vue";
import {
    FloorChartValueType,
    FloorChartVariableType,
    FloorGraphOption,
    FloorGraphType,
    GraphScopeType
} from "src/classLibrary/Charting/FloorChart";
import {Kore, SortType} from "@kirinnee/core";
import {GraphExportType} from "src/classLibrary/Constants";

@Component({
    components: {FloorChart, FloorChartOptions, Container}
})
export default class FloorAnalytics extends Vue {
    dialog = false;
    routeParams = {
        floorId: '',
    }
    routeQueries = {
        startTime: '',
        endTime: '',
        trades: [],
        type: 'horizontalBar',
        independent: 'sub',
        valueType: 'value',
        scope: 'Hour',
        merge: 'false',
    }

    loading = false;

    async Download(type: GraphExportType) {
        this.loading = true;
        await (this.$refs.Chart as any).Download(type);
        this.loading = false;
    }

    days: string[] = [];
    options: FloorGraphOption | null = null

    @Watch('$route', {deep: true})
    OnRouteChange() {
        this.options = this.Graph();
    }

    created() {
        this.Store.StoreValue.filter = 'graph';
        this.Store.StoreValue.rightIcon = 'tune';
    }

    destroyed() {
        this.Store.StoreValue.filter = '';
        this.Store.StoreValue.rightIcon = '';
    }

    async init() {
        const token = await this.$auth.AnalyticsToken;
        const pid = this.PersistentStore.StoreValue.project;
        const dayR = await this.$analyticsApi.Get<string[]>(`Analytics/${pid}/${this.routeParams.floorId}/days`, null, token);
        if (dayR.isOk()) {
            this.Store.StoreValue.filter = 'graph';
            this.Store.StoreValue.rightIcon = 'tune';
            const unwrapped = dayR.unwrap();
            const first = unwrapped.Sort(SortType.Descending, (s: string) => new Date(s) as any as number).Take();
            if (this.routeQueries.startTime === '' && this.routeQueries.endTime === '' && first != null) {
                const date = format(new Date(first), "yyyy/MM/dd");
                this.routeQueries.startTime = date;
                this.routeQueries.endTime = date;
            }
            this.days = unwrapped.Map(x => format(new Date(x), "yyyy/MM/dd"));
            this.options = this.Graph();
        }

    }

    Graph(): FloorGraphOption {
        const pid = this.PersistentStore.StoreValue.project
        return {
            valueType: this.routeQueries.valueType as FloorChartValueType,
            independent: this.routeQueries.independent as FloorChartVariableType,
            type: this.routeQueries.type as FloorGraphType,
            startTime: this.routeQueries.startTime,
            endTime: this.routeQueries.endTime,
            scope: GraphScopeType.Find(x => x.label === this.routeQueries.scope)?.value,
            projectId: pid,
            floorId: this.routeParams.floorId,
            trades: (new Kore()).WrapArray(this.routeQueries.trades),
            merge: this.routeQueries.merge === 'true' && (this.routeQueries.type != 'radar' && this.routeQueries.type != 'line')
        }
    }

}
</script>
